diff -ruNp linux-2.6.23.16/arch/x86_64/SYSCALLS.x86_64_ia32 linux-2.6.23.16-cher1/arch/x86_64/SYSCALLS.x86_64_ia32
--- linux-2.6.23.16/arch/x86_64/SYSCALLS.x86_64_ia32	1970-01-01 03:00:00.000000000 +0300
+++ linux-2.6.23.16-cher1/arch/x86_64/SYSCALLS.x86_64_ia32	2008-02-12 11:21:39.000000000 +0300
@@ -0,0 +1,332 @@
+sys_exit								OK
+stub32_fork                     arch/x86_64/ia32/ia32entry.S            CAP+
+sys_read                                                                OK
+sys_write                                                               OK
+compat_sys_open                 fs/compat.c                             CAP
+sys_close                       fs/open.c                               OK
+sys32_waitpid                   arch/x86_64/ia32/sys_ia32.c             CAP
+sys_creat                       fs/open.c                               CAP
+sys_link                        fs/namei.c                              REDIR
+sys_unlink                      fs/namei.c                              CAP+
+stub32_execve                   arch/x86_64/ia32/ia32entry.S            CAP+
+sys_chdir			fs/open.c				CAP
+compat_sys_time                 kernel/compat.c                         OK
+sys_mknod                       fs/namei.c                              REDIR
+sys_chmod			fs/open.c                               CAP+
+sys_lchown16                    kernel/uid16.c                          REDIR
+quiet_ni_syscall                                                        ---
+sys_stat                        fs/stat.c                               CAP
+sys32_lseek                     arch/x86_64/ia32/sys_ia32.c             REDIR
+sys_getpid                      kernel/timer.c                          OK
+compat_sys_mount                fs/compat.c                             CAP+
+sys_oldumount                   fs/namespace.c                          REDIR
+sys_setuid16                    kernel/uid16.c                          REDIR
+sys_getuid16	                kernel/uid16.c                          OK
+compat_sys_stime                kernel/compat.c                         CAP+
+sys32_ptrace                    arch/x86_64/ia32/ptrace32.c             CAP+
+sys_alarm                       kernel/timer.c                          OK
+sys_fstat                       fs/stat.c                               CAP
+sys_pause                       kernel/signal.c                         CAP
+compat_sys_utime                fs/compat.c                             CAP+
+quiet_ni_syscall                                                        ---
+quiet_ni_syscall                                                        ---
+sys_access			fs/open.c				CAP
+sys_nice                        kernel/sched.c                          CAP
+quiet_ni_syscall                                                        ---
+sys_sync                        fs/sync.c                               CAP
+sys32_kill                      arch/x86_64/ia32/sys_ia32.c             REDIR
+sys_rename                      fs/namei.c                              REDIR
+sys_mkdir                       fs/namei.c                              REDIR
+sys_rmdir                       fs/namei.c                              CAP+
+sys_dup                         fs/fcntl.c                              CAP
+sys32_pipe                      arch/x86_64/ia32/sys_ia32.c             CAP
+compat_sys_times                kernel/compat.c                         OK
+quiet_ni_syscall                                                        ---
+sys_brk                                                                 OK
+sys_setgid16                    kernel/uid16.c                          REDIR
+sys_getgid16                    kernel/uid16.c                          OK
+sys_signal                      kernel/signal.c                         OK
+sys_geteuid16                   kernel/uid16.c                          OK
+sys_getegid16                   kernel/uid16.c                          OK
+sys_acct                        kernel/acct.c                           CAP+
+sys_umount                      fs/namespace.c                          CAP+
+quiet_ni_syscall                                                        ---
+compat_sys_ioctl                fs/compat_ioctl.c                       CAP
+compat_sys_fcntl64              fs/compat.c                             CAP
+quiet_ni_syscall                                                        ---
+sys_setpgid                     kernel/sys.c                            CAP
+quiet_ni_syscall                                                        ---
+sys32_olduname                  arch/x86_64/ia32/sys_ia32.c             OK
+sys_umask                       kernel/sys.c                            CAP
+sys_chroot			fs/open.c				CAP+
+sys32_ustat                     arch/x86_64/ia32/sys_ia32.c             REDIR
+sys_dup2                        fs/fcntl.c                              CAP
+sys_getppid                     kernel/timer.c                          OK
+sys_getpgrp                     kernel/sys.c                            OK
+sys_setsid                      kernel/sys.c                            CAP
+sys32_sigaction                 arch/x86_64/ia32/sys_ia32.c             OK
+sys_sgetmask                    kernel/signal.c                         OK
+sys_ssetmask                    kernel/signal.c                         CAP
+sys_setreuid16                  kernel/uid16.c                          REDIR
+sys_setregid16                  kernel/uid16.c                          REDIR
+stub32_sigsuspend               arch/x86_64/ia32/ia32_signal.c          CAP
+compat_sys_sigpending           kernel/compat.c                         REDIR
+sys_sethostname                 kernel/sys.c                            CAP+
+compat_sys_setrlimit            kernel/compat.c                         REDIR
+compat_sys_old_getrlimit        kernel/compat.c                         OK
+compat_sys_getrusage            kernel/compat.c                         OK
+sys32_gettimeofday              arch/x86_64/ia32/sys_ia32.c             OK
+sys32_settimeofday              arch/x86_64/ia32/sys_ia32.c             CAP+
+sys_getgroups16                 kernel/uid16.c                          REDIR
+sys_setgroups16                 kernel/uid16.c                          CAP+
+sys32_old_select                arch/x86_64/ia32/sys_ia32.c             OK
+sys_symlink                     fs/namei.c                              REDIR
+sys_lstat                       fs/stat.c                               CAP
+sys_readlink                    fs/stat.c                               REDIR
+sys_uselib                      fs/exec.c                               CAP
+sys_swapon                      mm/swapfile.c                           CAP+
+sys_reboot                      kernel/sys.c                            CAP+
+compat_sys_old_readdir          fs/compat.c                             CAP
+sys32_mmap                      arch/x86_64/ia32/sys_ia32.c             OK
+sys_munmap                                                              OK
+sys_truncate			fs/open.c				CAP
+sys_ftruncate			fs/open.c				CAP
+sys_fchmod		        fs/open.c                               CAP+
+sys_fchown16                    kernel/uid16.c                          REDIR
+sys_getpriority                 kernel/sys.c                            CAP
+sys_setpriority                 kernel/sys.c                            CAP
+quiet_ni_syscall                                                        ---
+compat_sys_statfs               fs/compat.c                             CAP
+compat_sys_fstatfs              fs/compat.c                             CAP
+sys_ioperm                      arch/x86_64/kernel/ioport.c             CAP+
+compat_sys_socketcall           net/compat.c                            CAP+
+sys_syslog                      kernel/printk.c                         CAP
+compat_sys_setitimer            kernel/compat.c                         OK
+compat_sys_getitimer            kernel/compat.c                         OK
+compat_sys_newstat              fs/compat.c                             CAP
+compat_sys_newlstat             fs/compat.c                             CAP
+compat_sys_newfstat             fs/compat.c                             CAP
+sys32_uname                     arch/x86_64/ia32/sys_ia32.c             OK
+stub32_iopl                     arch/x86_64/ia32/ia32entry.S            REDIR
+sys_vhangup			fs/open.c                               CAP
+quiet_ni_syscall                                                        ---
+sys32_vm86_warning              arch/x86_64/ia32/sys_ia32.c             CAP+
+compat_sys_wait4                kernel/compat.c                         REDIR
+sys_swapoff                     mm/swapfile.c                           CAP+
+compat_sys_sysinfo              kernel/compat.c                         CAP
+sys32_ipc                       arch/x86_64/ia32/ipc32.c                CAP+
+sys_fsync                       fs/sync.c                               CAP
+stub32_sigreturn                                                        OK
+stub32_clone                    arch/x86_64/ia32/ia32entry.S            REDIR
+sys_setdomainname               kernel/sys.c                            CAP+
+sys_uname                                                               OK
+sys_modify_ldt                  arch/x86_64/kernel/ldt.c                CAP+
+compat_sys_adjtimex             kernel/compat.c                         CAP+
+sys32_mprotect                  arch/x86_64/ia32/sys_ia32.c             REDIR
+compat_sys_sigprocmask          kernel/compat.c                         REDIR
+quiet_ni_syscall                                                        ---
+sys_init_module			kernel/module.c                         CAP+
+sys_delete_module               kernel/module.c                         CAP+
+quiet_ni_syscall                                                        ---
+sys_quotactl                    fs/quota.c                              CAP+
+sys_getpgid                     kernel/sys.c                            CAP
+sys_fchdir			fs/open.c				CAP
+quiet_ni_syscall                                                        ---
+sys_sysfs                       fs/filesystems.c                        CAP
+sys_personality                 kernel/exec_domain.c                    CAP
+quiet_ni_syscall                                                        ---
+sys_setfsuid16                  kernel/uid16.c                          REDIR
+sys_setfsgid16                  kernel/uid16.c                          REDIR
+sys_llseek                      fs/read_write.c                         CAP
+compat_sys_getdents             fs/compat.c                             CAP+
+compat_sys_select               fs/compat.c                             OK
+sys_flock                       fs/locks.c                              CAP+
+sys_msync                                                               OK
+compat_sys_readv                                                        OK
+compat_sys_writev                                                       OK
+sys_getsid                      kernel/sys.c                            CAP
+sys_fdatasync                   fs/sync.c                               CAP
+sys32_sysctl                    arch/x86_64/ia32/sys_ia32.c             CAP+
+sys_mlock                       mm/mlock.c                              CAP+
+sys_munlock                     mm/mlock.c                              CAP+
+sys_mlockall                    mm/mlock.c                              CAP+
+sys_munlockall                  mm/mlock.c                              CAP+
+sys_sched_setparam              kernel/sched.c                          CAP
+sys_sched_getparam              kernel/sched.c                          CAP
+sys_sched_setscheduler          kernel/sched.c                          CAP
+sys_sched_getscheduler          kernel/sched.c                          CAP
+sys_sched_yield                 kernel/sched.c                          OK
+sys_sched_get_priority_max      kernel/sched.c                          OK
+sys_sched_get_priority_min      kernel/sched.c                          OK
+sys32_sched_rr_get_interval     arch/x86_64/ia32/sys_ia32.c             REDIR
+compat_sys_nanosleep            kernel/compat.c                         OK?
+sys_mremap                      mm/mremap.c                             OK
+sys_setresuid16                 kernel/uid16.c                          REDIR
+sys_getresuid16                 kernel/uid16.c                          OK?
+sys32_vm86_warning              arch/x86_64/ia32/sys_ia32.c             CAP+
+quiet_ni_syscall                                                        ---
+sys_poll                                                                OK
+compat_sys_nfsservctl           fs/compat.c                             CAP+
+sys_setresgid16                 kernel/uid16.c                          REDIR
+sys_getresgid16                 kernel/uid16.c                          OK?
+sys_prctl                       kernel/sys.c                            CAP
+stub32_rt_sigreturn                                                     OK
+sys32_rt_sigaction                                                      OK
+sys32_rt_sigprocmask            arch/x86_64/ia32/sys_ia32.c             REDIR
+sys32_rt_sigpending             arch/x86_64/ia32/sys_ia32.c             REDIR
+compat_sys_rt_sigtimedwait      kernel/compat.c                         CAP
+sys32_rt_sigqueueinfo           arch/x86_64/ia32/sys_ia32.c             REDIR
+stub32_rt_sigsuspend            arch/x86_64/ia32/ia32entry.S            REDIR
+sys32_pread                     arch/x86_64/ia32/sys_ia32.c             REDIR
+sys32_pwrite                    arch/x86_64/ia32/sys_ia32.c             REDIR
+sys_chown16                     kernel/uid16.c                          REDIR
+sys_getcwd                      fs/dcache.c                             CAP
+sys_capget                      kernel/capability.c                     CAP
+sys_capset                      kernel/capability.c                     CAP+
+stub32_sigaltstack              arch/x86_64/ia32/ia32_signal.c          CAP
+sys32_sendfile                  arch/x86_64/ia32/sys_ia32.c             REDIR
+quiet_ni_syscall                                                        ---
+quiet_ni_syscall                                                        ---
+stub32_vfork                    arch/x86_64/ia32/ia32entry.S            REDIR
+compat_sys_getrlimit            kernel/compat.c                         REDIR
+sys32_mmap2                                                             OK
+sys32_truncate64                arch/x86_64/ia32/sys_ia32.c             REDIR
+sys32_ftruncate64               arch/x86_64/ia32/sys_ia32.c             REDIR
+sys32_stat64                    arch/x86_64/ia32/sys_ia32.c             CAP
+sys32_lstat64                   arch/x86_64/ia32/sys_ia32.c             CAP
+sys32_fstat64                   arch/x86_64/ia32/sys_ia32.c             CAP
+sys_lchown                      fs/open.c                               CAP+
+sys_getuid                      kernel/timer.c                          OK
+sys_getgid                      kernel/timer.c                          OK
+sys_geteuid                     kernel/timer.c                          OK
+sys_getegid                     kernel/timer.c                          OK
+sys_setreuid                    kernel/sys.c                            CAP+
+sys_setregid                    kernel/sys.c                            CAP+
+sys_getgroups                   kernel/sys.c                            OK
+sys_setgroups                   kernel/sys.c                            CAP+
+sys_fchown                      fs/open.c                               CAP+
+sys_setresuid                   kernel/sys.c                            CAP+
+sys_getresuid                   kernel/sys.c                            OK
+sys_setresgid                   kernel/sys.c                            CAP+
+sys_getresgid                   kernel/sys.c                            OK
+sys_chown			fs/open.c				CAP+
+sys_setuid                      kernel/sys.c                            CAP+
+sys_setgid                      kernel/sys.c                            CAP+
+sys_setfsuid                    kernel/sys.c                            CAP+
+sys_setfsgid                    kernel/sys.c                            CAP+
+sys_pivot_root                  fs/namespace.c                          CAP+
+sys_mincore                     mm/mincore.c                            CAP
+sys_madvise                     mm/madvise.c                            CAP
+compat_sys_getdents64           fs/compat.c                             CAP+
+compat_sys_fcntl64              fs/compat.c                             CAP
+quiet_ni_syscall                                                        ---
+quiet_ni_syscall                                                        ---
+sys_gettid                      kernel/timer.c                          OK
+sys32_readahead                 arch/x86_64/ia32/sys_ia32.c             REDIR
+sys_setxattr                    fs/xattr.c                              CAP+
+sys_lsetxattr                   fs/xattr.c                              CAP+
+sys_fsetxattr                   fs/xattr.c                              CAP+
+sys_getxattr                    fs/xattr.c                              CAP+
+sys_lgetxattr                   fs/xattr.c                              CAP+
+sys_fgetxattr                   fs/xattr.c                              CAP+
+sys_listxattr                   fs/xattr.c                              CAP+
+sys_llistxattr                  fs/xattr.c                              CAP+
+sys_flistxattr                  fs/xattr.c                              CAP+
+sys_removexattr                 fs/xattr.c                              CAP+
+sys_lremovexattr                fs/xattr.c                              CAP+
+sys_fremovexattr                fs/xattr.c                              CAP+
+sys_tkill                       fs/signal.c                             CAP
+sys_sendfile64                  fs/read_write.c                         CAP
+compat_sys_futex                                                        OK
+compat_sys_sched_setaffinity    kernel/compat.c                         CAP
+compat_sys_sched_getaffinity    kernel/compat.c                         CAP
+sys32_set_thread_area                                                   OK
+sys32_get_thread_area                                                   OK
+compat_sys_io_setup             fs/compat.c                             REDIR
+sys_io_destroy                  fs/aio.c                                CAP
+compat_sys_io_getevents         fs/compat.c                             REDIR
+compat_sys_io_submit            fs/compat.c                             REDIR
+sys_io_cancel                   fs/aio.c                                CAP
+sys32_fadvise64                 arch/x86_64/ia32/sys_ia32.c             REDIR
+quiet_ni_syscall                                                        ---
+sys_exit_group			kernel/exit.c				OK?
+sys32_lookup_dcookie            arch/x86_64/ia32/sys_ia32.c             REDIR
+sys_epoll_create                fs/eventpoll.c                          CAP
+sys_epoll_ctl                   fs/eventpoll.c                          CAP
+sys_epoll_wait                  fs/eventpoll.c                          CAP
+sys_remap_file_pages            mm/fremap.c                             OK?
+sys_set_tid_address                                                     OK
+compat_sys_timer_create         kernel/compat.c                         REDIR
+compat_sys_timer_settime        kernel/compat.c                         REDIR
+compat_sys_timer_gettime        kernel/compat.c                         REDIR
+sys_timer_getoverrun            kernel/posix-timers.c                   CAP
+sys_timer_delete                kernel/posix-timers.c                   CAP
+compat_sys_clock_settime        kernel/compat.c                         REDIR
+compat_sys_clock_gettime        kernel/compat.c                         REDIR
+compat_sys_clock_getres         kernel/compat.c                         REDIR
+compat_sys_clock_nanosleep      kernel/compat.c                         REDIR
+compat_sys_statfs64             fs/compat.c                             CAP
+compat_sys_fstatfs64            fs/compat.c                             CAP
+sys_tgkill                      kernel/signal.c                         CAP
+compat_sys_utimes               fs/compat.c                             REDIR
+sys32_fadvise64_64              arch/x86_64/ia32/sys_ia32.c             REDIR
+quiet_ni_syscall                                                        ---
+sys_mbind                       mm/mempolicy.c                          CAP
+compat_sys_get_mempolicy        mm/mempolicy.c                          REDIR
+sys_set_mempolicy               mm/mempolicy.c                          CAP
+compat_sys_mq_open              ipc/compat_mq.c                         REDIR
+sys_mq_unlink                   ipc/mqueue.c                            CAP
+compat_sys_mq_timedsend         ipc/compat_mq.c                         REDIR
+compat_sys_mq_timedreceive      ipc/compat_mq.c                         REDIR
+compat_sys_mq_notify            ipc/compat_mq.c                         REDIR
+compat_sys_mq_getsetattr        ipc/compat_mq.c                         REDIR
+compat_sys_kexec_load           kernel/kexec.c                          REDIR
+compat_sys_waitid               kernel/compat.c                         REDIR
+quiet_ni_syscall                                                        ---
+sys_add_key                     security/keys/keyctl.c                  CAP+
+sys_request_key                 security/keys/keyctl.c                  CAP+
+sys_keyctl                      security/keys/keyctl.c                  CAP+
+sys_ioprio_set                  fs/ioprio.c                             CAP+
+sys_ioprio_get                  fs/ioprio.c                             CAP+
+sys_inotify_init                fs/inotify_user.c                       CAP
+sys_inotify_add_watch           fs/inotify_user.c                       CAP
+sys_inotify_rm_watch            fs/inotify_user.c                       CAP
+sys_migrate_pages               mm/mempolicy.c                          CAP
+compat_sys_openat               fs/compat.c                             CAP
+sys_mkdirat                     fs/namei.c                              CAP+
+sys_mknodat                     fs/namei.c                              CAP+
+sys_fchownat			fs/open.c				CAP+
+compat_sys_futimesat            fs/compat.c                             CAP+
+sys32_fstatat                   arch/x86_64/ia32/sys_ia32.c             CAP
+sys_unlinkat                    fs/namei.c                              CAP+
+sys_renameat                    fs/namei.c                              CAP+
+sys_linkat                      fs/namei.c                              CAP+
+sys_symlinkat                   fs/namei.c                              CAP+
+sys_readlinkat                  fs/stat.c                               CAP
+sys_fchmodat	        	fs/open.c				CAP+
+sys_faccessat			fs/open.c				CAP
+compat_sys_pselect6                                                     OK
+compat_sys_ppoll                                                        OK
+sys_unshare                     kernel/fork.c                           CAP
+compat_sys_set_robust_list                                              OK
+compat_sys_get_robust_list                                              OK
+sys_splice                      fs/splice.c                             CAP
+sys32_sync_file_range           arch/x86_64/ia32/sys_ia32.c             REDIR
+sys_tee                         fs/splice.c                             CAP
+compat_sys_vmsplice             fs/compat.c                             REDIR
+compat_sys_move_pages           kernel/compat.c                         REDIR
+sys_getcpu                      kernel/sys.c                            CAP
+sys_epoll_pwait                 fs/eventpoll.c                          CAP
+compat_sys_utimensat            fs/compat.c                             CAP+
+compat_sys_signalfd             fs/compat.c                             REDIR
+compat_sys_timerfd              fs/compat.c                             REDIR
+sys_eventfd                     fs/eventfd.c                            CAP
+sys_fallocate			arch/x86_64/ia32/sys_ia32.c		REDIR
+
+=== END OF SYSCALL TABLE ===
+*) The line number corresponds to syscall number
+
+Syscall 0:
+sys_restart_syscall             kernel/signal.c                         OK
+
+syscall table is in arch/x86_64/ia32/ia32entry.S
diff -ruNp linux-2.6.23.16/fs/aio.c linux-2.6.23.16-cher1/fs/aio.c
--- linux-2.6.23.16/fs/aio.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/fs/aio.c	2008-02-12 11:21:39.000000000 +0300
@@ -1249,6 +1249,9 @@ asmlinkage long sys_io_setup(unsigned nr
 	unsigned long ctx;
 	long ret;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	ret = get_user(ctx, ctxp);
 	if (unlikely(ret))
 		goto out;
@@ -1283,7 +1286,12 @@ out:
  */
 asmlinkage long sys_io_destroy(aio_context_t ctx)
 {
-	struct kioctx *ioctx = lookup_ioctx(ctx);
+        struct kioctx *ioctx = 0;
+
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
+        ioctx = lookup_ioctx(ctx);
 	if (likely(NULL != ioctx)) {
 		io_destroy(ioctx);
 		return 0;
@@ -1634,6 +1642,9 @@ asmlinkage long sys_io_submit(aio_contex
 	long ret = 0;
 	int i;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	if (unlikely(nr < 0))
 		return -EINVAL;
 
@@ -1711,6 +1722,9 @@ asmlinkage long sys_io_cancel(aio_contex
 	u32 key;
 	int ret;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	ret = get_user(key, &iocb->aio_key);
 	if (unlikely(ret))
 		return -EFAULT;
@@ -1770,9 +1784,13 @@ asmlinkage long sys_io_getevents(aio_con
 				 struct io_event __user *events,
 				 struct timespec __user *timeout)
 {
-	struct kioctx *ioctx = lookup_ioctx(ctx_id);
+	struct kioctx *ioctx = 0;
 	long ret = -EINVAL;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
+        ioctx = lookup_ioctx(ctx_id);
 	if (likely(ioctx)) {
 		if (likely(min_nr <= nr && min_nr >= 0 && nr >= 0))
 			ret = read_events(ioctx, min_nr, nr, events, timeout);
@@ -1787,3 +1805,9 @@ __initcall(aio_setup);
 EXPORT_SYMBOL(aio_complete);
 EXPORT_SYMBOL(aio_put_req);
 EXPORT_SYMBOL(wait_on_sync_kiocb);
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.23.16/fs/binfmt_aout.c linux-2.6.23.16-cher1/fs/binfmt_aout.c
--- linux-2.6.23.16/fs/binfmt_aout.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/fs/binfmt_aout.c	2008-02-12 11:21:39.000000000 +0300
@@ -294,8 +294,12 @@ static int load_aout_binary(struct linux
 	rlim = current->signal->rlim[RLIMIT_DATA].rlim_cur;
 	if (rlim >= RLIM_INFINITY)
 		rlim = ~0;
-	if (ex.a_data + ex.a_bss > rlim)
+	if (ex.a_data + ex.a_bss > rlim) {
+                if ((current->sbox_flags & SBOX_MEMLIMITON)) {
+                        current->sbox_flags |= SBOX_WAS_MEMLIMIT;
+                }
 		return -ENOMEM;
+        }
 
 	/* Flush all traces of the currently running executable */
 	retval = flush_old_exec(bprm);
@@ -560,3 +564,9 @@ static void __exit exit_aout_binfmt(void
 core_initcall(init_aout_binfmt);
 module_exit(exit_aout_binfmt);
 MODULE_LICENSE("GPL");
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.23.16/fs/binfmt_flat.c linux-2.6.23.16-cher1/fs/binfmt_flat.c
--- linux-2.6.23.16/fs/binfmt_flat.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/fs/binfmt_flat.c	2008-02-12 11:21:39.000000000 +0300
@@ -496,6 +496,9 @@ static int load_flat_file(struct linux_b
 	if (rlim >= RLIM_INFINITY)
 		rlim = ~0;
 	if (data_len + bss_len > rlim) {
+                if ((current->sbox_flags & SBOX_MEMLIMITON)) {
+                        current->sbox_flags |= SBOX_WAS_MEMLIMIT;
+                }
 		ret = -ENOMEM;
 		goto err;
 	}
@@ -942,3 +945,9 @@ core_initcall(init_flat_binfmt);
 module_exit(exit_flat_binfmt);
 
 /****************************************************************************/
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.23.16/fs/buffer.c linux-2.6.23.16-cher1/fs/buffer.c
--- linux-2.6.23.16/fs/buffer.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/fs/buffer.c	2008-02-12 11:21:39.000000000 +0300
@@ -2909,6 +2909,9 @@ asmlinkage long sys_bdflush(int func, lo
 {
 	static int msg_count;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	if (!capable(CAP_SYS_ADMIN))
 		return -EPERM;
 
